/* A Bison parser, made by GNU Bison 2.1.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse mdl_parse
#define yylex   mdl_lex
#define yyerror mdl_error
#define yylval  mdl_lval
#define yychar  mdl_char
#define yydebug mdl_debug
#define yynerrs mdl_nerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     LINK = 258,
     Identifier = 259,
     String = 260,
     InvalidCharacter = 261,
     Real = 262,
     t_LINK = 263,
     t_VIEW = 264,
     t_TABLE = 265,
     t_PSTABLE = 266,
     t_CNTABLE = 267,
     t_BLKEDIT = 268,
     t_HYPTABLE = 269,
     t_ELEMENT = 270,
     t_DATA = 271,
     t_DATASET = 272,
     t_DATASIZE = 273,
     t_POINT = 274,
     t_MEMBER = 275,
     t_LIST = 276,
     t_PLOTOPTIMIZEROPT = 277,
     t_PLOTERROR = 278,
     t_TYPE = 279,
     t_CIRCUITDECK = 280,
     t_PARAM = 281,
     t_CONNPAIR = 282
   };
#endif
/* Tokens.  */
#define LINK 258
#define Identifier 259
#define String 260
#define InvalidCharacter 261
#define Real 262
#define t_LINK 263
#define t_VIEW 264
#define t_TABLE 265
#define t_PSTABLE 266
#define t_CNTABLE 267
#define t_BLKEDIT 268
#define t_HYPTABLE 269
#define t_ELEMENT 270
#define t_DATA 271
#define t_DATASET 272
#define t_DATASIZE 273
#define t_POINT 274
#define t_MEMBER 275
#define t_LIST 276
#define t_PLOTOPTIMIZEROPT 277
#define t_PLOTERROR 278
#define t_TYPE 279
#define t_CIRCUITDECK 280
#define t_PARAM 281
#define t_CONNPAIR 282




/* Copy the first part of user declarations.  */
#line 3 "parse_mdl.y"

/*
 * parse_mdl.y - parser for an IC-CAP MDL data file
 *
 * Copyright (C) 2006 Stefan Jahn <stefan@lkcc.org>
 *
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this package; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.  
 *
 * $Id: parse_mdl.y,v 1.2 2006/08/21 08:10:30 raimi Exp $
 *
 */

#if HAVE_CONFIG_H
# include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define YYERROR_VERBOSE 42
#define YYDEBUG 1
#define YYMAXDEPTH 1000000

#include "object.h"
#include "complex.h"
#include "vector.h"
#include "check_mdl.h"



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 76 "parse_mdl.y"
typedef union YYSTYPE {
  char * ident;
  double f;
  struct mdl_point_t * point;
  struct mdl_dataset_t * dset;
  struct mdl_datasize_t * dsize;
  struct mdl_link_t * link;
  struct mdl_data_t * data;
  struct mdl_dcontent_t * dcontent;
  struct mdl_lcontent_t * lcontent;
  struct mdl_element_t * element;
  struct mdl_hyptable_t * hyptable;
  struct mdl_table_t * table;
} YYSTYPE;
/* Line 196 of yacc.c.  */
#line 207 "parse_mdl.cpp"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 219 of yacc.c.  */
#line 219 "parse_mdl.cpp"

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T) && (defined (__STDC__) || defined (__cplusplus))
# include <stddef.h> /* INFRINGES ON USER NAME SPACE */
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if defined (__STDC__) || defined (__cplusplus)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     define YYINCLUDED_STDLIB_H
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2005 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM ((YYSIZE_T) -1)
#  endif
#  ifdef __cplusplus
extern "C" {
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if (! defined (malloc) && ! defined (YYINCLUDED_STDLIB_H) \
	&& (defined (__STDC__) || defined (__cplusplus)))
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if (! defined (free) && ! defined (YYINCLUDED_STDLIB_H) \
	&& (defined (__STDC__) || defined (__cplusplus)))
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifdef __cplusplus
}
#  endif
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   103

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  30
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  37
/* YYNRULES -- Number of rules. */
#define YYNRULES  63
/* YYNRULES -- Number of states. */
#define YYNSTATES  129

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   282

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    28,     2,    29,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
       0,     0,     3,     5,     7,     9,    11,    12,    15,    17,
      19,    20,    23,    25,    26,    29,    31,    33,    35,    37,
      39,    41,    42,    45,    47,    49,    51,    53,    55,    57,
      59,    61,    63,    64,    67,    69,    70,    73,    77,    83,
      85,    86,    89,    95,   100,   104,   109,   115,   122,   127,
     133,   137,   142,   148,   154,   159,   165,   168,   175,   179,
     183,   187,   191,   195
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      31,     0,    -1,    50,    -1,    48,    -1,    47,    -1,    49,
      -1,    -1,    32,    33,    -1,    48,    -1,    47,    -1,    -1,
      34,    35,    -1,    66,    -1,    -1,    36,    37,    -1,    48,
      -1,    61,    -1,    64,    -1,    49,    -1,    50,    -1,    51,
      -1,    -1,    38,    39,    -1,    62,    -1,    63,    -1,    49,
      -1,    52,    -1,    55,    -1,    56,    -1,    57,    -1,    54,
      -1,    53,    -1,    -1,    40,    41,    -1,    65,    -1,    -1,
      42,    43,    -1,    58,    59,    46,    -1,    58,    59,    46,
      59,    46,    -1,    60,    -1,    -1,    45,    46,    -1,    15,
       7,     5,     5,     5,    -1,    15,     7,     5,     5,    -1,
      15,     5,     5,    -1,     9,     4,     7,     5,    -1,    10,
       5,    28,    33,    29,    -1,     3,     8,     5,    28,    39,
      29,    -1,    16,    28,    41,    29,    -1,    11,     5,    28,
      43,    29,    -1,    25,    28,    29,    -1,    13,     5,    28,
      29,    -1,    12,     5,    28,    37,    29,    -1,    14,     5,
      28,    35,    29,    -1,    17,    28,    44,    29,    -1,    18,
       4,     7,     7,     7,    -1,    24,     4,    -1,    19,     7,
       7,     7,     7,     7,    -1,    21,     8,     5,    -1,    22,
       4,     7,    -1,    23,     4,     7,    -1,    20,     8,     5,
      -1,    26,     4,     5,    -1,    27,     5,     5,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   108,   108,   114,   117,   120,   125,   126,   137,   140,
     145,   146,   157,   160,   161,   166,   169,   172,   175,   180,
     185,   192,   193,   204,   207,   210,   213,   216,   219,   224,
     229,   232,   237,   238,   249,   252,   253,   258,   264,   275,
     278,   279,   286,   293,   299,   307,   314,   322,   331,   338,
     344,   348,   354,   360,   368,   374,   384,   390,   401,   408,
     414,   420,   427,   434
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "LINK", "Identifier", "String",
  "InvalidCharacter", "Real", "t_LINK", "t_VIEW", "t_TABLE", "t_PSTABLE",
  "t_CNTABLE", "t_BLKEDIT", "t_HYPTABLE", "t_ELEMENT", "t_DATA",
  "t_DATASET", "t_DATASIZE", "t_POINT", "t_MEMBER", "t_LIST",
  "t_PLOTOPTIMIZEROPT", "t_PLOTERROR", "t_TYPE", "t_CIRCUITDECK",
  "t_PARAM", "t_CONNPAIR", "'{'", "'}'", "$accept", "Input",
  "TableContent", "TableContentList", "HypTableContent",
  "HypTableContentList", "ConnTableContent", "ConnTableContentList",
  "LinkContent", "LinkContentList", "DataContent", "DataContentList",
  "PSContent", "PSContentList", "DSContent", "Point", "PointList",
  "ELEMENT_Line", "VIEW_Line", "TABLE_Definition", "LINK_Definition",
  "DATA_Definition", "PSTABLE_Definition", "CIRCUITDECK_Definition",
  "BLKEDIT_Definition", "CNTABLE_Definition", "HYPTABLE_Definition",
  "DATASET_Definition", "DATASIZE_Line", "TYPE_Line", "POINT_Line",
  "LIST_Line", "PLOTOPTIMIZEROPT_Line", "PLOTERROR_Line", "MEMBER_Line",
  "PARAM_Line", "CONNPAIR_Line", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   123,   125
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    30,    31,    32,    32,    32,    33,    33,    34,    34,
      35,    35,    36,    37,    37,    38,    38,    38,    38,    38,
      38,    39,    39,    40,    40,    40,    40,    40,    40,    40,
      40,    40,    41,    41,    42,    43,    43,    44,    44,    45,
      46,    46,    47,    47,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     1,     1,     1,     0,     2,     1,     1,
       0,     2,     1,     0,     2,     1,     1,     1,     1,     1,
       1,     0,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     2,     1,     0,     2,     3,     5,     1,
       0,     2,     5,     4,     3,     4,     5,     6,     4,     5,
       3,     4,     5,     5,     4,     5,     2,     6,     3,     3,
       3,     3,     3,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     0,     0,     2,     0,     1,     0,    21,     0,     0,
       0,     0,     0,    21,     0,    15,    18,    19,    20,    16,
      17,     0,     0,    32,     0,     0,    22,    47,     0,     6,
       0,     0,     0,     0,     0,     0,     0,     0,    32,     0,
      25,    26,    31,    30,    27,    28,    29,    23,    24,    61,
      58,    45,     0,     6,     0,     4,     3,     5,     0,     0,
       0,     0,     0,     0,     0,     0,    33,    48,     0,     0,
       7,    46,    35,    13,     0,    10,     0,     0,     0,    59,
      60,    50,    44,     0,     0,    35,     0,    34,     0,    13,
       0,    12,    51,    10,     0,     9,     8,     0,    54,     0,
      40,    43,     0,    36,    49,     0,    14,    52,    11,    53,
       0,    56,     0,    40,    37,    39,    42,    62,    63,     0,
       0,    41,    40,    55,     0,    38,     0,     0,    57
};

/* YYDEFGOTO[NTERM-NUM]. */
static const yysigned_char yydefgoto[] =
{
      -1,     2,    53,    54,    93,    94,    89,    90,    13,    14,
      38,    39,    85,    86,    77,   113,   114,    55,    15,    16,
      17,    18,    41,    42,    43,    44,    45,    46,    78,   100,
     115,    19,    47,    48,    20,    87,    91
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -96
static const yysigned_char yypact[] =
{
       1,    -3,     6,   -96,    25,   -96,     8,    -1,    33,    34,
      10,    32,    35,    -1,    12,   -96,   -96,   -96,   -96,   -96,
     -96,    37,    14,     0,    40,    42,   -96,   -96,    43,    19,
      44,    45,    46,    47,    26,    49,    51,    29,     0,    27,
     -96,   -96,   -96,   -96,   -96,   -96,   -96,   -96,   -96,   -96,
     -96,   -96,    28,    19,    30,   -96,   -96,   -96,    38,    39,
      41,    48,    50,    53,    54,    36,   -96,   -96,    57,    58,
     -96,   -96,    52,    31,    55,    17,    66,    56,    59,   -96,
     -96,   -96,   -96,    67,    69,    52,    60,   -96,    70,    31,
      61,   -96,   -96,    17,    62,   -96,   -96,    64,   -96,    73,
      63,    74,    75,   -96,   -96,    76,   -96,   -96,   -96,   -96,
      79,   -96,    80,    63,    59,   -96,   -96,   -96,   -96,    81,
      85,   -96,    63,   -96,    86,   -96,    87,    88,   -96
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -96,   -96,   -96,    21,   -96,     3,   -96,     9,   -96,    84,
     -96,    65,   -96,    15,   -96,   -96,   -95,   -72,   -29,   -22,
      99,   -96,   -96,   -96,   -96,   -96,   -96,   -96,   -96,   -13,
     -96,   -96,   -96,   -96,   -96,   -96,   -96
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
      56,    40,     1,    95,     1,     4,     5,    57,     8,     9,
       9,    30,    31,    32,    33,    10,    40,    34,   121,    11,
      12,    95,    35,    36,    56,    37,     8,   125,     8,     9,
       6,    57,    52,    68,    52,    69,     7,    21,    23,    22,
      24,    27,    29,    25,    28,    49,    96,    50,    51,    58,
      59,    60,    61,    63,    62,    64,    67,    65,    88,    71,
      79,    80,    82,    83,    96,    81,    72,    73,    76,    74,
      97,   110,   101,   102,    70,   105,    75,   111,    84,   116,
     117,   118,   112,    99,    92,    98,   119,   120,   123,   104,
     107,   109,   124,   126,   127,   128,   108,    26,   106,     3,
     103,   122,     0,    66
};

static const yysigned_char yycheck[] =
{
      29,    23,     3,    75,     3,     8,     0,    29,     9,    10,
      10,    11,    12,    13,    14,    16,    38,    17,   113,    20,
      21,    93,    22,    23,    53,    25,     9,   122,     9,    10,
       5,    53,    15,     5,    15,     7,    28,     4,    28,     5,
       8,    29,    28,     8,     7,     5,    75,     5,     5,     5,
       5,     5,     5,     4,    28,     4,    29,    28,    27,    29,
       7,     7,     5,     5,    93,    29,    28,    28,    18,    28,
       4,     7,     5,     4,    53,     5,    28,     4,    26,     5,
       5,     5,    19,    24,    29,    29,     7,     7,     7,    29,
      29,    29,     7,     7,     7,     7,    93,    13,    89,     0,
      85,   114,    -1,    38
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     3,    31,    50,     8,     0,     5,    28,     9,    10,
      16,    20,    21,    38,    39,    48,    49,    50,    51,    61,
      64,     4,     5,    28,     8,     8,    39,    29,     7,    28,
      11,    12,    13,    14,    17,    22,    23,    25,    40,    41,
      49,    52,    53,    54,    55,    56,    57,    62,    63,     5,
       5,     5,    15,    32,    33,    47,    48,    49,     5,     5,
       5,     5,    28,     4,     4,    28,    41,    29,     5,     7,
      33,    29,    28,    28,    28,    28,    18,    44,    58,     7,
       7,    29,     5,     5,    26,    42,    43,    65,    27,    36,
      37,    66,    29,    34,    35,    47,    48,     4,    29,    24,
      59,     5,     4,    43,    29,     5,    37,    29,    35,    29,
       7,     4,    19,    45,    46,    60,     5,     5,     5,     7,
       7,    46,    59,     7,     7,    46,     7,     7,     7
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (0)


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
              (Loc).first_line, (Loc).first_column,	\
              (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr,					\
                  Type, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname[yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      size_t yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

#endif /* YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);


# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()
    ;
#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a look-ahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to look-ahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 108 "parse_mdl.y"
    {
    mdl_root = (yyvsp[0].link);
  }
    break;

  case 3:
#line 114 "parse_mdl.y"
    {
    (yyval.element) = NULL;
  }
    break;

  case 4:
#line 117 "parse_mdl.y"
    {
    (yyval.element) = (yyvsp[0].element);
  }
    break;

  case 5:
#line 120 "parse_mdl.y"
    {
    (yyval.element) = NULL;
  }
    break;

  case 6:
#line 125 "parse_mdl.y"
    { (yyval.element) = NULL; }
    break;

  case 7:
#line 126 "parse_mdl.y"
    {
    if ((yyvsp[-1].element)) {
      (yyvsp[-1].element)->next = (yyvsp[0].element);
      (yyval.element) = (yyvsp[-1].element);
    } else {
      (yyval.element) = (yyvsp[0].element);
    }
  }
    break;

  case 8:
#line 137 "parse_mdl.y"
    {
    (yyval.element) = NULL;
  }
    break;

  case 9:
#line 140 "parse_mdl.y"
    {
    (yyval.element) = (yyvsp[0].element);
  }
    break;

  case 10:
#line 145 "parse_mdl.y"
    { (yyval.element) = NULL; }
    break;

  case 11:
#line 146 "parse_mdl.y"
    {
    if ((yyvsp[-1].element)) {
      (yyvsp[-1].element)->next = (yyvsp[0].element);
      (yyval.element) = (yyvsp[-1].element);
    } else {
      (yyval.element) = (yyvsp[0].element);
    }
  }
    break;

  case 13:
#line 160 "parse_mdl.y"
    { }
    break;

  case 14:
#line 161 "parse_mdl.y"
    {
  }
    break;

  case 15:
#line 166 "parse_mdl.y"
    {
    (yyval.lcontent) = NULL;
  }
    break;

  case 16:
#line 169 "parse_mdl.y"
    {
    (yyval.lcontent) = NULL;
  }
    break;

  case 17:
#line 172 "parse_mdl.y"
    {
    (yyval.lcontent) = NULL;
  }
    break;

  case 18:
#line 175 "parse_mdl.y"
    {
    (yyval.lcontent) = (struct mdl_lcontent_t *) calloc (sizeof (struct mdl_lcontent_t), 1);
    (yyval.lcontent)->type = t_TABLE;
    (yyval.lcontent)->table = (yyvsp[0].table);
  }
    break;

  case 19:
#line 180 "parse_mdl.y"
    {
    (yyval.lcontent) = (struct mdl_lcontent_t *) calloc (sizeof (struct mdl_lcontent_t), 1);
    (yyval.lcontent)->type = t_LINK;
    (yyval.lcontent)->link = (yyvsp[0].link);
  }
    break;

  case 20:
#line 185 "parse_mdl.y"
    {
    (yyval.lcontent) = (struct mdl_lcontent_t *) calloc (sizeof (struct mdl_lcontent_t), 1);
    (yyval.lcontent)->type = t_DATA;
    (yyval.lcontent)->data = (yyvsp[0].data);
  }
    break;

  case 21:
#line 192 "parse_mdl.y"
    { (yyval.lcontent) = NULL; }
    break;

  case 22:
#line 193 "parse_mdl.y"
    {
    if ((yyvsp[-1].lcontent)) {
      (yyvsp[-1].lcontent)->next = (yyvsp[0].lcontent);
      (yyval.lcontent) = (yyvsp[-1].lcontent);
    } else {
      (yyval.lcontent) = (yyvsp[0].lcontent);
    }
  }
    break;

  case 23:
#line 204 "parse_mdl.y"
    {
    (yyval.dcontent) = NULL;
  }
    break;

  case 24:
#line 207 "parse_mdl.y"
    {
    (yyval.dcontent) = NULL;
  }
    break;

  case 25:
#line 210 "parse_mdl.y"
    {
    (yyval.dcontent) = NULL;
  }
    break;

  case 26:
#line 213 "parse_mdl.y"
    {
    (yyval.dcontent) = NULL;
  }
    break;

  case 27:
#line 216 "parse_mdl.y"
    {
    (yyval.dcontent) = NULL;
  }
    break;

  case 28:
#line 219 "parse_mdl.y"
    {
    (yyval.dcontent) = (struct mdl_dcontent_t *) calloc (sizeof (struct mdl_dcontent_t), 1);
    (yyval.dcontent)->type = t_HYPTABLE;
    (yyval.dcontent)->hyptable = (yyvsp[0].hyptable);
  }
    break;

  case 29:
#line 224 "parse_mdl.y"
    {
    (yyval.dcontent) = (struct mdl_dcontent_t *) calloc (sizeof (struct mdl_dcontent_t), 1);
    (yyval.dcontent)->type = t_DATASET;
    (yyval.dcontent)->data = (yyvsp[0].dset);
  }
    break;

  case 30:
#line 229 "parse_mdl.y"
    {
    (yyval.dcontent) = NULL;
  }
    break;

  case 31:
#line 232 "parse_mdl.y"
    {
    (yyval.dcontent) = NULL;
  }
    break;

  case 32:
#line 237 "parse_mdl.y"
    { (yyval.dcontent) = NULL; }
    break;

  case 33:
#line 238 "parse_mdl.y"
    {
    if ((yyvsp[-1].dcontent)) {
      (yyvsp[-1].dcontent)->next = (yyvsp[0].dcontent);
      (yyval.dcontent) = (yyvsp[-1].dcontent);
    } else {
      (yyval.dcontent) = (yyvsp[0].dcontent);
    }
  }
    break;

  case 35:
#line 252 "parse_mdl.y"
    { }
    break;

  case 36:
#line 253 "parse_mdl.y"
    {
  }
    break;

  case 37:
#line 258 "parse_mdl.y"
    {
    (yyval.dset) = (struct mdl_dataset_t *) calloc (sizeof (struct mdl_dataset_t), 1);
    (yyval.dset)->dsize = (yyvsp[-2].dsize);
    (yyval.dset)->type1 = (yyvsp[-1].ident);
    (yyval.dset)->data1 = (yyvsp[0].point);
  }
    break;

  case 38:
#line 264 "parse_mdl.y"
    {
    (yyval.dset) = (struct mdl_dataset_t *) calloc (sizeof (struct mdl_dataset_t), 1);
    (yyval.dset)->dsize = (yyvsp[-4].dsize);
    (yyval.dset)->type1 = (yyvsp[-3].ident);
    (yyval.dset)->data1 = (yyvsp[-2].point);
    (yyval.dset)->type2 = (yyvsp[-1].ident);
    (yyval.dset)->data2 = (yyvsp[0].point);
  }
    break;

  case 40:
#line 278 "parse_mdl.y"
    { (yyval.point) = NULL; }
    break;

  case 41:
#line 279 "parse_mdl.y"
    {
    (yyvsp[-1].point)->next = (yyvsp[0].point);
    (yyval.point) = (yyvsp[-1].point);
  }
    break;

  case 42:
#line 286 "parse_mdl.y"
    {
    (yyval.element) = (struct mdl_element_t *) calloc (sizeof (struct mdl_element_t), 1);
    (yyval.element)->number = (int) (yyvsp[-3].f);
    (yyval.element)->name = (yyvsp[-2].ident);
    (yyval.element)->value = (yyvsp[-1].ident);
    (yyval.element)->attr = (yyvsp[0].ident);
  }
    break;

  case 43:
#line 293 "parse_mdl.y"
    {
    (yyval.element) = (struct mdl_element_t *) calloc (sizeof (struct mdl_element_t), 1);
    (yyval.element)->number = (int) (yyvsp[-2].f);
    (yyval.element)->name = (yyvsp[-1].ident);
    (yyval.element)->value = (yyvsp[0].ident);
  }
    break;

  case 44:
#line 299 "parse_mdl.y"
    {
    (yyval.element) = (struct mdl_element_t *) calloc (sizeof (struct mdl_element_t), 1);
    (yyval.element)->name = (yyvsp[-1].ident);
    (yyval.element)->value = (yyvsp[0].ident);
  }
    break;

  case 45:
#line 307 "parse_mdl.y"
    {
    free ((yyvsp[-2].ident));
    free ((yyvsp[0].ident));
  }
    break;

  case 46:
#line 314 "parse_mdl.y"
    {
    (yyval.table) = (struct mdl_table_t *) calloc (sizeof (struct mdl_table_t), 1);
    (yyval.table)->name = (yyvsp[-3].ident);
    (yyval.table)->data = (yyvsp[-1].element);
  }
    break;

  case 47:
#line 322 "parse_mdl.y"
    {
    (yyval.link) = (struct mdl_link_t *) calloc (sizeof (struct mdl_link_t), 1);
    (yyval.link)->name = (yyvsp[-3].ident);
    (yyval.link)->type = (yyvsp[-4].ident);
    (yyval.link)->content = (yyvsp[-1].lcontent);
  }
    break;

  case 48:
#line 331 "parse_mdl.y"
    {
    (yyval.data) = (struct mdl_data_t *) calloc (sizeof (struct mdl_data_t), 1);
    (yyval.data)->content = (yyvsp[-1].dcontent);
  }
    break;

  case 49:
#line 338 "parse_mdl.y"
    {
    free ((yyvsp[-3].ident));
  }
    break;

  case 51:
#line 348 "parse_mdl.y"
    {
    free ((yyvsp[-2].ident));
  }
    break;

  case 52:
#line 354 "parse_mdl.y"
    {
    free ((yyvsp[-3].ident));
  }
    break;

  case 53:
#line 360 "parse_mdl.y"
    {
    (yyval.hyptable) = (struct mdl_hyptable_t *) calloc (sizeof (struct mdl_hyptable_t), 1);
    (yyval.hyptable)->name = (yyvsp[-3].ident);
    (yyval.hyptable)->data = (yyvsp[-1].element);
  }
    break;

  case 54:
#line 368 "parse_mdl.y"
    {
    (yyval.dset) = (yyvsp[-1].dset);
  }
    break;

  case 55:
#line 374 "parse_mdl.y"
    {
    (yyval.dsize) = (struct mdl_datasize_t *) calloc (sizeof (struct mdl_datasize_t), 1);
    (yyval.dsize)->type = (yyvsp[-3].ident);
    (yyval.dsize)->size = (int) (yyvsp[-2].f);
    (yyval.dsize)->x = (int) (yyvsp[-1].f);
    (yyval.dsize)->y = (int) (yyvsp[0].f);
  }
    break;

  case 56:
#line 384 "parse_mdl.y"
    {
    (yyval.ident) = (yyvsp[0].ident);
  }
    break;

  case 57:
#line 390 "parse_mdl.y"
    {
    (yyval.point) = (struct mdl_point_t *) calloc (sizeof (struct mdl_point_t), 1);
    (yyval.point)->n = (int) (yyvsp[-4].f);
    (yyval.point)->x = (int) (yyvsp[-3].f);
    (yyval.point)->y = (int) (yyvsp[-2].f);
    (yyval.point)->r = (yyvsp[-1].f);
    (yyval.point)->i = (yyvsp[0].f);
  }
    break;

  case 58:
#line 401 "parse_mdl.y"
    {
    free ((yyvsp[-1].ident));
    free ((yyvsp[0].ident));
  }
    break;

  case 59:
#line 408 "parse_mdl.y"
    {
    free ((yyvsp[-1].ident));
  }
    break;

  case 60:
#line 414 "parse_mdl.y"
    {
    free ((yyvsp[-1].ident));
  }
    break;

  case 61:
#line 420 "parse_mdl.y"
    {
    free ((yyvsp[-1].ident));
    free ((yyvsp[0].ident));
  }
    break;

  case 62:
#line 427 "parse_mdl.y"
    {
    free ((yyvsp[-1].ident));
    free ((yyvsp[0].ident));
  }
    break;

  case 63:
#line 434 "parse_mdl.y"
    {
    free ((yyvsp[-1].ident));
    free ((yyvsp[0].ident));
  }
    break;


      default: break;
    }

/* Line 1126 of yacc.c.  */
#line 1776 "parse_mdl.cpp"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  int yytype = YYTRANSLATE (yychar);
	  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
	  YYSIZE_T yysize = yysize0;
	  YYSIZE_T yysize1;
	  int yysize_overflow = 0;
	  char *yymsg = 0;
#	  define YYERROR_VERBOSE_ARGS_MAXIMUM 5
	  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
	  int yyx;

#if 0
	  /* This is so xgettext sees the translatable formats that are
	     constructed on the fly.  */
	  YY_("syntax error, unexpected %s");
	  YY_("syntax error, unexpected %s, expecting %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s or %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
#endif
	  char *yyfmt;
	  char const *yyf;
	  static char const yyunexpected[] = "syntax error, unexpected %s";
	  static char const yyexpecting[] = ", expecting %s";
	  static char const yyor[] = " or %s";
	  char yyformat[sizeof yyunexpected
			+ sizeof yyexpecting - 1
			+ ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
			   * (sizeof yyor - 1))];
	  char const *yyprefix = yyexpecting;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 1;

	  yyarg[0] = yytname[yytype];
	  yyfmt = yystpcpy (yyformat, yyunexpected);

	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
		  {
		    yycount = 1;
		    yysize = yysize0;
		    yyformat[sizeof yyunexpected - 1] = '\0';
		    break;
		  }
		yyarg[yycount++] = yytname[yyx];
		yysize1 = yysize + yytnamerr (0, yytname[yyx]);
		yysize_overflow |= yysize1 < yysize;
		yysize = yysize1;
		yyfmt = yystpcpy (yyfmt, yyprefix);
		yyprefix = yyor;
	      }

	  yyf = YY_(yyformat);
	  yysize1 = yysize + yystrlen (yyf);
	  yysize_overflow |= yysize1 < yysize;
	  yysize = yysize1;

	  if (!yysize_overflow && yysize <= YYSTACK_ALLOC_MAXIMUM)
	    yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg)
	    {
	      /* Avoid sprintf, as that infringes on the user's name space.
		 Don't have undefined behavior even if the translation
		 produced a string with the wrong number of "%s"s.  */
	      char *yyp = yymsg;
	      int yyi = 0;
	      while ((*yyp = *yyf))
		{
		  if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		    {
		      yyp += yytnamerr (yyp, yyarg[yyi++]);
		      yyf += 2;
		    }
		  else
		    {
		      yyp++;
		      yyf++;
		    }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    {
	      yyerror (YY_("syntax error"));
	      goto yyexhaustedlab;
	    }
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror (YY_("syntax error"));
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
        }
      else
	{
	  yydestruct ("Error: discarding", yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (0)
     goto yyerrorlab;

yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping", yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK;
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 440 "parse_mdl.y"


int mdl_error (char * error) {
  fprintf (stderr, "line %d: %s\n", mdl_lineno, error);
  return 0;
}

