/* A Bison parser, made by GNU Bison 2.1.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse netlist_parse
#define yylex   netlist_lex
#define yyerror netlist_error
#define yylval  netlist_lval
#define yychar  netlist_char
#define yydebug netlist_debug
#define yynerrs netlist_nerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     InvalidCharacter = 258,
     Identifier = 259,
     Assign = 260,
     ScaleOrUnit = 261,
     Eol = 262,
     Eqn = 263,
     DefSub = 264,
     EndSub = 265,
     REAL = 266,
     IMAG = 267,
     COMPLEX = 268,
     Character = 269,
     STRING = 270,
     NEG = 271,
     POS = 272
   };
#endif
/* Tokens.  */
#define InvalidCharacter 258
#define Identifier 259
#define Assign 260
#define ScaleOrUnit 261
#define Eol 262
#define Eqn 263
#define DefSub 264
#define EndSub 265
#define REAL 266
#define IMAG 267
#define COMPLEX 268
#define Character 269
#define STRING 270
#define NEG 271
#define POS 272




/* Copy the first part of user declarations.  */
#line 3 "parse_netlist.y"

/*
 * parse_netlist.y - parser for the Qucs netlist
 *
 * Copyright (C) 2003, 2004, 2005, 2006 Stefan Jahn <stefan@lkcc.org>
 *
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this package; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.  
 *
 * $Id: parse_netlist.y,v 1.21 2006/07/24 08:07:42 raimi Exp $
 *
 */

#if HAVE_CONFIG_H
# include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define YYERROR_VERBOSE 42
#define YYDEBUG 1
#define YYMAXDEPTH 1000000

#include "check_netlist.h"
#include "logging.h"
#include "equation.h"
#include "range.h"



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 71 "parse_netlist.y"
typedef union YYSTYPE {
  char * ident;
  char * str;
  double d;
  char chr;
  struct definition_t * definition;
  struct definition_t * subcircuit;
  struct node_t * node;
  struct pair_t * pair;
  struct value_t * value;
  struct {
    double r;
    double i;
  } c;
  eqn::node * eqn;
  eqn::constant * con;
  eqn::reference * ref;
  eqn::application * app;
  eqn::assignment * assign;
} YYSTYPE;
/* Line 196 of yacc.c.  */
#line 192 "parse_netlist.cpp"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 219 of yacc.c.  */
#line 204 "parse_netlist.cpp"

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T) && (defined (__STDC__) || defined (__cplusplus))
# include <stddef.h> /* INFRINGES ON USER NAME SPACE */
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if defined (__STDC__) || defined (__cplusplus)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     define YYINCLUDED_STDLIB_H
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2005 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM ((YYSIZE_T) -1)
#  endif
#  ifdef __cplusplus
extern "C" {
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if (! defined (malloc) && ! defined (YYINCLUDED_STDLIB_H) \
	&& (defined (__STDC__) || defined (__cplusplus)))
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if (! defined (free) && ! defined (YYINCLUDED_STDLIB_H) \
	&& (defined (__STDC__) || defined (__cplusplus)))
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifdef __cplusplus
}
#  endif
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  19
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   133

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  34
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  28
/* YYNRULES -- Number of rules. */
#define YYNRULES  71
/* YYNRULES -- Number of states. */
#define YYNSTATES  116

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   272

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    27,     2,     2,    22,     2,     2,
      31,    32,    20,    19,    33,    18,    26,    21,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    17,    30,
       2,    16,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    28,     2,    29,    25,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    23,    24
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
       0,     0,     3,     4,     7,     9,    11,    13,    15,    17,
      24,    31,    33,    35,    37,    39,    40,    43,    44,    48,
      52,    53,    56,    58,    62,    64,    67,    71,    73,    75,
      79,    80,    82,    86,    93,    94,    97,   102,   104,   106,
     108,   112,   114,   116,   118,   120,   124,   127,   130,   132,
     134,   139,   144,   148,   152,   156,   160,   164,   167,   170,
     174,   176,   177,   179,   183,   187,   192,   193,   196,   199,
     201,   203
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      35,     0,    -1,    -1,    36,    35,    -1,    57,    -1,    48,
      -1,    37,    -1,    38,    -1,     7,    -1,    26,     4,    17,
      39,    42,     7,    -1,     4,    17,    39,    41,    42,     7,
      -1,     4,    -1,     6,    -1,     4,    -1,     6,    -1,    -1,
      40,    41,    -1,    -1,     5,    44,    42,    -1,     5,    43,
      42,    -1,    -1,    27,    27,    -1,    46,    -1,    27,    46,
      27,    -1,    11,    -1,    11,     6,    -1,    11,     6,     6,
      -1,    45,    -1,    39,    -1,    28,    47,    29,    -1,    -1,
      45,    -1,    45,    30,    47,    -1,     8,    17,    39,    50,
      49,     7,    -1,    -1,    50,    49,    -1,     5,    27,    51,
      27,    -1,    52,    -1,    54,    -1,    55,    -1,    31,    51,
      32,    -1,    11,    -1,    12,    -1,    14,    -1,    15,    -1,
      51,    17,    51,    -1,    17,    51,    -1,    51,    17,    -1,
      17,    -1,     4,    -1,     4,    31,    56,    32,    -1,    54,
      28,    56,    29,    -1,    51,    19,    51,    -1,    51,    18,
      51,    -1,    51,    20,    51,    -1,    51,    21,    51,    -1,
      51,    22,    51,    -1,    19,    51,    -1,    18,    51,    -1,
      51,    25,    51,    -1,    53,    -1,    -1,    51,    -1,    51,
      33,    56,    -1,    58,    59,    60,    -1,     9,    39,    41,
       7,    -1,    -1,    61,    59,    -1,    10,     7,    -1,    38,
      -1,    57,    -1,     7,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   111,   111,   112,   116,   120,   121,   125,   129,   133,
     144,   156,   157,   161,   162,   165,   166,   173,   174,   180,
     193,   194,   198,   201,   207,   211,   216,   225,   228,   232,
     237,   238,   242,   249,   257,   258,   265,   273,   276,   279,
     282,   288,   292,   296,   300,   307,   314,   323,   332,   346,
     353,   360,   368,   375,   382,   389,   396,   403,   409,   415,
     422,   427,   428,   432,   439,   447,   458,   459,   471,   475,
     479,   480
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "InvalidCharacter", "Identifier",
  "Assign", "ScaleOrUnit", "Eol", "Eqn", "DefSub", "EndSub", "REAL",
  "IMAG", "COMPLEX", "Character", "STRING", "'='", "':'", "'-'", "'+'",
  "'*'", "'/'", "'%'", "NEG", "POS", "'^'", "'.'", "'\"'", "'['", "']'",
  "';'", "'('", "')'", "','", "$accept", "Input", "InputLine",
  "ActionLine", "DefinitionLine", "InstanceIdentifier", "NodeIdentifier",
  "NodeList", "PairList", "NoneValue", "Value", "PropertyReal",
  "PropertyValue", "ValueList", "EquationLine", "EquationList", "Equation",
  "Expression", "Constant", "Range", "Reference", "Application",
  "ExpressionList", "SubcircuitBody", "DefBegin", "DefBody", "DefEnd",
  "DefBodyLine", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,    61,    58,    45,    43,
      42,    47,    37,   271,   272,    94,    46,    34,    91,    93,
      59,    40,    41,    44
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    34,    35,    35,    36,    36,    36,    36,    36,    37,
      38,    39,    39,    40,    40,    41,    41,    42,    42,    42,
      43,    43,    44,    44,    45,    45,    45,    46,    46,    46,
      47,    47,    47,    48,    49,    49,    50,    51,    51,    51,
      51,    52,    52,    52,    52,    53,    53,    53,    53,    54,
      55,    55,    55,    55,    55,    55,    55,    55,    55,    55,
      55,    56,    56,    56,    57,    58,    59,    59,    60,    61,
      61,    61
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     2,     1,     1,     1,     1,     1,     6,
       6,     1,     1,     1,     1,     0,     2,     0,     3,     3,
       0,     2,     1,     3,     1,     2,     3,     1,     1,     3,
       0,     1,     3,     6,     0,     2,     4,     1,     1,     1,
       3,     1,     1,     1,     1,     3,     2,     2,     1,     1,
       4,     4,     3,     3,     3,     3,     3,     2,     2,     3,
       1,     0,     1,     3,     3,     4,     0,     2,     2,     1,
       1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       2,     0,     8,     0,     0,     0,     0,     2,     6,     7,
       5,     4,    66,     0,     0,    11,    12,    15,     0,     1,
       3,    71,    69,    70,     0,    66,    15,     0,    13,    14,
      15,     0,     0,     0,    64,    67,    17,     0,    34,    16,
      65,    17,    68,    20,     0,     0,     0,    34,     0,    24,
       0,    30,    28,    17,    17,    27,    22,    10,    49,    41,
      42,    43,    44,    48,     0,     0,     0,     0,    37,    60,
      38,    39,    33,    35,     9,    25,    21,     0,    31,     0,
      19,    18,    61,    46,    58,    57,     0,    47,     0,     0,
       0,     0,     0,     0,    36,    61,    26,    23,    30,    29,
      62,     0,    40,    45,    53,    52,    54,    55,    56,    59,
       0,    32,    61,    50,    51,    63
};

/* YYDEFGOTO[NTERM-NUM]. */
static const yysigned_char yydefgoto[] =
{
      -1,     6,     7,     8,     9,    52,    30,    31,    44,    53,
      54,    55,    56,    79,    10,    46,    47,   100,    68,    69,
      70,    71,   101,    11,    12,    24,    34,    25
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -91
static const yysigned_char yypact[] =
{
      -1,    -8,   -91,    -5,    35,    11,    32,    -1,   -91,   -91,
     -91,   -91,    85,    35,    35,   -91,   -91,    48,    18,   -91,
     -91,   -91,   -91,   -91,    30,    85,    48,    51,   -91,   -91,
      48,    56,    35,    57,   -91,   -91,    52,    41,    51,   -91,
     -91,    52,   -91,    49,    66,    19,    78,    51,    81,    80,
      63,    82,   -91,    52,    52,   -91,   -91,   -91,    71,   -91,
     -91,   -91,   -91,    47,    19,    19,    19,    88,   -91,   -91,
      75,   -91,   -91,   -91,   -91,   106,   -91,    87,    91,    93,
     -91,   -91,    19,    98,    99,    99,    79,    47,    19,    19,
      19,    19,    19,    19,   -91,    19,   -91,   -91,    82,   -91,
      62,    94,   -91,    98,    50,    50,    99,    99,    99,    99,
      96,   -91,    19,   -91,   -91,   -91
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -91,   120,   -91,   -91,     1,    -3,   -91,    -2,   -37,   -91,
     -91,   -49,    83,    31,   -91,    84,   101,   -45,   -91,   -91,
     -91,   -91,   -90,     2,   -91,   105,   -91,   -91
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
      67,    17,    78,     1,    48,   110,     2,     3,     4,    13,
      26,    27,    14,    22,    23,    18,    80,    81,    83,    84,
      85,    86,   115,    58,    36,     5,    22,    23,    39,    41,
      59,    60,    19,    61,    62,    32,    63,    64,    65,    15,
      33,    16,   103,   104,   105,   106,   107,   108,   109,    78,
      66,    58,    28,    15,    29,    16,    37,    43,    59,    60,
      49,    61,    62,    40,    42,    64,    65,    15,    45,    16,
      90,    91,    92,    57,    49,    93,    50,    51,    66,    87,
      88,    89,    90,    91,    92,    72,    75,    93,    74,     1,
      76,    51,    21,    49,     4,   112,    87,    88,    89,    90,
      91,    92,    82,    95,    93,    87,    88,    89,    90,    91,
      92,   102,    96,    93,    97,    94,    88,    89,    90,    91,
      92,    98,    99,    93,    93,   114,   113,    20,    38,   111,
      35,    73,     0,    77
};

static const yysigned_char yycheck[] =
{
      45,     4,    51,     4,    41,    95,     7,     8,     9,    17,
      13,    14,    17,    12,    12,     4,    53,    54,    63,    64,
      65,    66,   112,     4,    26,    26,    25,    25,    30,    32,
      11,    12,     0,    14,    15,    17,    17,    18,    19,     4,
      10,     6,    87,    88,    89,    90,    91,    92,    93,    98,
      31,     4,     4,     4,     6,     6,     5,     5,    11,    12,
      11,    14,    15,     7,     7,    18,    19,     4,    27,     6,
      20,    21,    22,     7,    11,    25,    27,    28,    31,    17,
      18,    19,    20,    21,    22,     7,     6,    25,     7,     4,
      27,    28,     7,    11,     9,    33,    17,    18,    19,    20,
      21,    22,    31,    28,    25,    17,    18,    19,    20,    21,
      22,    32,     6,    25,    27,    27,    18,    19,    20,    21,
      22,    30,    29,    25,    25,    29,    32,     7,    27,    98,
      25,    47,    -1,    50
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     4,     7,     8,     9,    26,    35,    36,    37,    38,
      48,    57,    58,    17,    17,     4,     6,    39,     4,     0,
      35,     7,    38,    57,    59,    61,    39,    39,     4,     6,
      40,    41,    17,    10,    60,    59,    41,     5,    50,    41,
       7,    39,     7,     5,    42,    27,    49,    50,    42,    11,
      27,    28,    39,    43,    44,    45,    46,     7,     4,    11,
      12,    14,    15,    17,    18,    19,    31,    51,    52,    53,
      54,    55,     7,    49,     7,     6,    27,    46,    45,    47,
      42,    42,    31,    51,    51,    51,    51,    17,    18,    19,
      20,    21,    22,    25,    27,    28,     6,    27,    30,    29,
      51,    56,    32,    51,    51,    51,    51,    51,    51,    51,
      56,    47,    33,    32,    29,    56
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (0)


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
              (Loc).first_line, (Loc).first_column,	\
              (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr,					\
                  Type, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname[yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      size_t yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

#endif /* YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);


# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()
    ;
#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a look-ahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to look-ahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 4:
#line 116 "parse_netlist.y"
    { /* chain definition root */
    (yyvsp[0].subcircuit)->next = definition_root;
    definition_root = (yyvsp[0].subcircuit);
  }
    break;

  case 5:
#line 120 "parse_netlist.y"
    { /* nothing to do here */ }
    break;

  case 6:
#line 121 "parse_netlist.y"
    { /* chain definition root */
    (yyvsp[0].definition)->next = definition_root;
    definition_root = (yyvsp[0].definition);
  }
    break;

  case 7:
#line 125 "parse_netlist.y"
    { /* chain definition root */
    (yyvsp[0].definition)->next = definition_root;
    definition_root = (yyvsp[0].definition);
  }
    break;

  case 8:
#line 129 "parse_netlist.y"
    { }
    break;

  case 9:
#line 133 "parse_netlist.y"
    { 
    (yyval.definition) = (struct definition_t *) calloc (sizeof (struct definition_t), 1);
    (yyval.definition)->action = PROP_ACTION;
    (yyval.definition)->type = (yyvsp[-4].ident);
    (yyval.definition)->instance = (yyvsp[-2].ident);
    (yyval.definition)->pairs = (yyvsp[-1].pair);
    (yyval.definition)->line = netlist_lineno;
  }
    break;

  case 10:
#line 144 "parse_netlist.y"
    { 
    (yyval.definition) = (struct definition_t *) calloc (sizeof (struct definition_t), 1);
    (yyval.definition)->action = PROP_COMPONENT;
    (yyval.definition)->type = (yyvsp[-5].ident);
    (yyval.definition)->instance = (yyvsp[-3].ident);
    (yyval.definition)->nodes = (yyvsp[-2].node);
    (yyval.definition)->pairs = (yyvsp[-1].pair);
    (yyval.definition)->line = netlist_lineno;
  }
    break;

  case 11:
#line 156 "parse_netlist.y"
    { (yyval.ident) = (yyvsp[0].ident); }
    break;

  case 12:
#line 157 "parse_netlist.y"
    { (yyval.ident) = (yyvsp[0].str); }
    break;

  case 13:
#line 161 "parse_netlist.y"
    { (yyval.ident) = (yyvsp[0].ident); }
    break;

  case 14:
#line 162 "parse_netlist.y"
    { (yyval.ident) = (yyvsp[0].str); }
    break;

  case 15:
#line 165 "parse_netlist.y"
    { (yyval.node) = NULL; }
    break;

  case 16:
#line 166 "parse_netlist.y"
    {
    (yyval.node) = (struct node_t *) calloc (sizeof (struct node_t), 1);
    (yyval.node)->node = (yyvsp[-1].ident);
    (yyval.node)->next = (yyvsp[0].node);
  }
    break;

  case 17:
#line 173 "parse_netlist.y"
    { (yyval.pair) = NULL; }
    break;

  case 18:
#line 174 "parse_netlist.y"
    {
    (yyval.pair) = (struct pair_t *) calloc (sizeof (struct pair_t), 1);
    (yyval.pair)->key = (yyvsp[-2].ident);
    (yyval.pair)->value = (yyvsp[-1].value);
    (yyval.pair)->next = (yyvsp[0].pair);
  }
    break;

  case 19:
#line 180 "parse_netlist.y"
    {
    if (0) {
      (yyval.pair) = (struct pair_t *) calloc (sizeof (struct pair_t), 1);
      (yyval.pair)->key = (yyvsp[-2].ident);
      (yyval.pair)->value = NULL;
      (yyval.pair)->next = (yyvsp[0].pair);
    } else {
      free ((yyvsp[-2].ident));
      (yyval.pair) = (yyvsp[0].pair);
    }
  }
    break;

  case 20:
#line 193 "parse_netlist.y"
    { /* nothing */ }
    break;

  case 21:
#line 194 "parse_netlist.y"
    { /* also nothing */ }
    break;

  case 22:
#line 198 "parse_netlist.y"
    {
    (yyval.value) = (yyvsp[0].value);
  }
    break;

  case 23:
#line 201 "parse_netlist.y"
    {
    (yyval.value) = (yyvsp[-1].value);
  }
    break;

  case 24:
#line 207 "parse_netlist.y"
    {
    (yyval.value) = create_value ();
    (yyval.value)->value = (yyvsp[0].d);
  }
    break;

  case 25:
#line 211 "parse_netlist.y"
    {
    (yyval.value) = create_value ();
    (yyval.value)->value = (yyvsp[-1].d);
    (yyval.value)->scale = (yyvsp[0].str);
  }
    break;

  case 26:
#line 216 "parse_netlist.y"
    {
    (yyval.value) = create_value ();
    (yyval.value)->value = (yyvsp[-2].d);
    (yyval.value)->scale = (yyvsp[-1].str);
    (yyval.value)->unit = (yyvsp[0].str);
  }
    break;

  case 27:
#line 225 "parse_netlist.y"
    {
    (yyval.value) = (yyvsp[0].value);
  }
    break;

  case 28:
#line 228 "parse_netlist.y"
    {
    (yyval.value) = create_value ();
    (yyval.value)->ident = (yyvsp[0].ident);
  }
    break;

  case 29:
#line 232 "parse_netlist.y"
    {
    (yyval.value) = (yyvsp[-1].value);
  }
    break;

  case 30:
#line 237 "parse_netlist.y"
    { (yyval.value) = NULL; }
    break;

  case 31:
#line 238 "parse_netlist.y"
    {
    (yyvsp[0].value)->next = NULL;
    (yyval.value) = (yyvsp[0].value);
  }
    break;

  case 32:
#line 242 "parse_netlist.y"
    {
    (yyvsp[-2].value)->next = (yyvsp[0].value);
    (yyval.value) = (yyvsp[-2].value);
  }
    break;

  case 33:
#line 249 "parse_netlist.y"
    {
    (yyvsp[-2].assign)->setInstance ((yyvsp[-3].ident)); free ((yyvsp[-3].ident));
    (yyvsp[-2].assign)->setNext (eqn::equations);
    (yyvsp[-2].assign)->applyInstance ();
    eqn::equations = (yyvsp[-2].assign);
  }
    break;

  case 34:
#line 257 "parse_netlist.y"
    { }
    break;

  case 35:
#line 258 "parse_netlist.y"
    { 
    (yyvsp[-1].assign)->setNext (eqn::equations);
    eqn::equations = (yyvsp[-1].assign);
  }
    break;

  case 36:
#line 265 "parse_netlist.y"
    {
    (yyval.assign) = new eqn::assignment ();
    (yyval.assign)->result = (yyvsp[-3].ident);
    (yyval.assign)->body = (yyvsp[-1].eqn);
  }
    break;

  case 37:
#line 273 "parse_netlist.y"
    {
    (yyval.eqn) = (yyvsp[0].con);
  }
    break;

  case 38:
#line 276 "parse_netlist.y"
    {
    (yyval.eqn) = (yyvsp[0].ref);
  }
    break;

  case 39:
#line 279 "parse_netlist.y"
    {
    (yyval.eqn) = (yyvsp[0].app);
  }
    break;

  case 40:
#line 282 "parse_netlist.y"
    {
    (yyval.eqn) = (yyvsp[-1].eqn);
  }
    break;

  case 41:
#line 288 "parse_netlist.y"
    { 
    (yyval.con) = new eqn::constant (eqn::TAG_DOUBLE);
    (yyval.con)->d = (yyvsp[0].d);
  }
    break;

  case 42:
#line 292 "parse_netlist.y"
    {
    (yyval.con) = new eqn::constant (eqn::TAG_COMPLEX);
    (yyval.con)->c = new complex (0.0, (yyvsp[0].d));
  }
    break;

  case 43:
#line 296 "parse_netlist.y"
    {
    (yyval.con) = new eqn::constant (eqn::TAG_CHAR);
    (yyval.con)->chr = (yyvsp[0].chr);
  }
    break;

  case 44:
#line 300 "parse_netlist.y"
    {
    (yyval.con) = new eqn::constant (eqn::TAG_STRING);
    (yyval.con)->s = (yyvsp[0].str);
  }
    break;

  case 45:
#line 307 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("range");
    (yyval.app)->nargs = 2;
    (yyvsp[-2].eqn)->append ((yyvsp[0].eqn));
    (yyval.app)->args = (yyvsp[-2].eqn);
  }
    break;

  case 46:
#line 314 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("range");
    (yyval.app)->nargs = 2;
    eqn::constant * c = new eqn::constant (eqn::TAG_CHAR);
    c->chr = '?';
    c->append ((yyvsp[0].eqn));
    (yyval.app)->args = c;
  }
    break;

  case 47:
#line 323 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("range");
    (yyval.app)->nargs = 2;
    eqn::constant * c = new eqn::constant (eqn::TAG_CHAR);
    c->chr = '?';
    (yyvsp[-1].eqn)->append (c);
    (yyval.app)->args = (yyvsp[-1].eqn);
  }
    break;

  case 48:
#line 332 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("range");
    (yyval.app)->nargs = 2;
    eqn::constant * c1 = new eqn::constant (eqn::TAG_CHAR);
    eqn::constant * c2 = new eqn::constant (eqn::TAG_CHAR);
    c1->chr = '?';
    c2->chr = '?';
    c1->append (c2);
    (yyval.app)->args = c1;
  }
    break;

  case 49:
#line 346 "parse_netlist.y"
    {
    (yyval.ref) = new eqn::reference ();
    (yyval.ref)->n = (yyvsp[0].ident);
  }
    break;

  case 50:
#line 353 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = (yyvsp[-3].ident);
    (yyval.app)->nargs = (yyvsp[-1].eqn)->count ();
    (yyval.app)->args = (yyvsp[-1].eqn);
    eqn::expressions = NULL;
  }
    break;

  case 51:
#line 360 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("array");
    (yyval.app)->nargs = 1 + (yyvsp[-1].eqn)->count ();
    (yyvsp[-3].ref)->setNext ((yyvsp[-1].eqn));
    (yyval.app)->args = (yyvsp[-3].ref);
    eqn::expressions = NULL;
  }
    break;

  case 52:
#line 368 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("+");
    (yyval.app)->nargs = 2;
    (yyvsp[-2].eqn)->append ((yyvsp[0].eqn));
    (yyval.app)->args = (yyvsp[-2].eqn);
  }
    break;

  case 53:
#line 375 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("-");
    (yyval.app)->nargs = 2;
    (yyvsp[-2].eqn)->append ((yyvsp[0].eqn));
    (yyval.app)->args = (yyvsp[-2].eqn);
  }
    break;

  case 54:
#line 382 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("*");
    (yyval.app)->nargs = 2;
    (yyvsp[-2].eqn)->append ((yyvsp[0].eqn));
    (yyval.app)->args = (yyvsp[-2].eqn);
  }
    break;

  case 55:
#line 389 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("/");
    (yyval.app)->nargs = 2;
    (yyvsp[-2].eqn)->append ((yyvsp[0].eqn));
    (yyval.app)->args = (yyvsp[-2].eqn);
  }
    break;

  case 56:
#line 396 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("%");
    (yyval.app)->nargs = 2;
    (yyvsp[-2].eqn)->append ((yyvsp[0].eqn));
    (yyval.app)->args = (yyvsp[-2].eqn);
  }
    break;

  case 57:
#line 403 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("+");
    (yyval.app)->nargs = 1;
    (yyval.app)->args = (yyvsp[0].eqn);
  }
    break;

  case 58:
#line 409 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("-");
    (yyval.app)->nargs = 1;
    (yyval.app)->args = (yyvsp[0].eqn);
  }
    break;

  case 59:
#line 415 "parse_netlist.y"
    {
    (yyval.app) = new eqn::application ();
    (yyval.app)->n = strdup ("^");
    (yyval.app)->nargs = 2;
    (yyvsp[-2].eqn)->append ((yyvsp[0].eqn));
    (yyval.app)->args = (yyvsp[-2].eqn);
  }
    break;

  case 60:
#line 422 "parse_netlist.y"
    {
    (yyval.app) = (yyvsp[0].app);
  }
    break;

  case 61:
#line 427 "parse_netlist.y"
    { (yyval.eqn) = eqn::expressions = NULL; }
    break;

  case 62:
#line 428 "parse_netlist.y"
    {
    (yyvsp[0].eqn)->setNext (eqn::expressions);
    (yyval.eqn) = eqn::expressions = (yyvsp[0].eqn);
  }
    break;

  case 63:
#line 432 "parse_netlist.y"
    {
    (yyvsp[-2].eqn)->setNext (eqn::expressions);
    (yyval.eqn) = eqn::expressions = (yyvsp[-2].eqn);
  }
    break;

  case 64:
#line 439 "parse_netlist.y"
    { /* a full subcircuit definition found */
    (yyvsp[-2].subcircuit)->sub = (yyvsp[-1].definition);
    (yyval.subcircuit) = (yyvsp[-2].subcircuit);
    (yyvsp[-1].definition) = NULL;
  }
    break;

  case 65:
#line 447 "parse_netlist.y"
    {
    /* create subcircuit definition right here */
    (yyval.subcircuit) = (struct definition_t *) calloc (sizeof (struct definition_t), 1);
    (yyval.subcircuit)->type = strdup ("Def");
    (yyval.subcircuit)->instance = (yyvsp[-2].ident);
    (yyval.subcircuit)->nodes = (yyvsp[-1].node);
    (yyval.subcircuit)->action = PROP_ACTION;
    (yyval.subcircuit)->line = netlist_lineno;
  }
    break;

  case 66:
#line 458 "parse_netlist.y"
    { (yyval.definition) = NULL; }
    break;

  case 67:
#line 459 "parse_netlist.y"
    { /* chain definitions here */
    if ((yyvsp[-1].definition)) {
      (yyvsp[-1].definition)->next = (yyvsp[0].definition);
      (yyval.definition) = (yyvsp[-1].definition);
    }
    else {
      (yyval.definition) = (yyvsp[0].definition);
    }
  }
    break;

  case 68:
#line 471 "parse_netlist.y"
    { /* nothing to do */ }
    break;

  case 69:
#line 475 "parse_netlist.y"
    { /* chain definitions here */
    (yyvsp[0].definition)->next = (yyval.definition);
    (yyval.definition) = (yyvsp[0].definition);
  }
    break;

  case 70:
#line 479 "parse_netlist.y"
    { /* do nothing here, see subcircuit rule */ }
    break;

  case 71:
#line 480 "parse_netlist.y"
    {
    (yyval.definition) = NULL;
  }
    break;


      default: break;
    }

/* Line 1126 of yacc.c.  */
#line 1873 "parse_netlist.cpp"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  int yytype = YYTRANSLATE (yychar);
	  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
	  YYSIZE_T yysize = yysize0;
	  YYSIZE_T yysize1;
	  int yysize_overflow = 0;
	  char *yymsg = 0;
#	  define YYERROR_VERBOSE_ARGS_MAXIMUM 5
	  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
	  int yyx;

#if 0
	  /* This is so xgettext sees the translatable formats that are
	     constructed on the fly.  */
	  YY_("syntax error, unexpected %s");
	  YY_("syntax error, unexpected %s, expecting %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s or %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
#endif
	  char *yyfmt;
	  char const *yyf;
	  static char const yyunexpected[] = "syntax error, unexpected %s";
	  static char const yyexpecting[] = ", expecting %s";
	  static char const yyor[] = " or %s";
	  char yyformat[sizeof yyunexpected
			+ sizeof yyexpecting - 1
			+ ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
			   * (sizeof yyor - 1))];
	  char const *yyprefix = yyexpecting;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 1;

	  yyarg[0] = yytname[yytype];
	  yyfmt = yystpcpy (yyformat, yyunexpected);

	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
		  {
		    yycount = 1;
		    yysize = yysize0;
		    yyformat[sizeof yyunexpected - 1] = '\0';
		    break;
		  }
		yyarg[yycount++] = yytname[yyx];
		yysize1 = yysize + yytnamerr (0, yytname[yyx]);
		yysize_overflow |= yysize1 < yysize;
		yysize = yysize1;
		yyfmt = yystpcpy (yyfmt, yyprefix);
		yyprefix = yyor;
	      }

	  yyf = YY_(yyformat);
	  yysize1 = yysize + yystrlen (yyf);
	  yysize_overflow |= yysize1 < yysize;
	  yysize = yysize1;

	  if (!yysize_overflow && yysize <= YYSTACK_ALLOC_MAXIMUM)
	    yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg)
	    {
	      /* Avoid sprintf, as that infringes on the user's name space.
		 Don't have undefined behavior even if the translation
		 produced a string with the wrong number of "%s"s.  */
	      char *yyp = yymsg;
	      int yyi = 0;
	      while ((*yyp = *yyf))
		{
		  if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		    {
		      yyp += yytnamerr (yyp, yyarg[yyi++]);
		      yyf += 2;
		    }
		  else
		    {
		      yyp++;
		      yyf++;
		    }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    {
	      yyerror (YY_("syntax error"));
	      goto yyexhaustedlab;
	    }
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror (YY_("syntax error"));
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
        }
      else
	{
	  yydestruct ("Error: discarding", yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (0)
     goto yyerrorlab;

yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping", yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK;
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 486 "parse_netlist.y"


int netlist_error (char * error) {
  logprint (LOG_ERROR, "line %d: %s\n", netlist_lineno, error);
  return 0;
}

